ldconfig(8)

NAME
ldconfig - configure dynamic linker run-time bindings

SYNOPSIS
ldconfig [OPTION...]

DESCRIPTION
ldconfig creates the necessary links and cache (for use by the run-time linker, ld.so) to the most recent shared libraries found in the directories specified on the command line, in the file /etc/ld.so.conf, and in the trusted directories (/usr/lib and /lib). ldconfig checks the header and file names of the libraries it encounters when determining which versions should have their links updated. ldconfig ignores symbolic links when scanning for libraries.

ldconfig will attempt to deduce the type of ELF libs (ie. libc 5.x or libc 6.x (glibc)) based on what C libraries if any the library was linked against, therefore when making dynamic libraries, it is wise to explicitly link against libc (use -lc). ldconfig is capable of storing multiple ABI types of libraries into a single cache on architectures which allow native running of multiple ABIs, like ia32/ia64/x86_64 or sparc32/sparc64.

Some existing libs do not contain enough information to allow the deduction of their type, therefore the /etc/ld.so.conf file format allows the specification of an expected type. This is only used for those ELF libs which we can not work out. The format is like this "dirname=TYPE", where type can be libc4, libc5 or libc6. (This syntax also works on the command line). Spaces are not allowed. Also see the -p option.

Directory names containing an = are no longer legal unless they also have an expected type specifier.

ldconfig should normally be run by the super-user as it may require write permission on some root owned directories and files. If you use -r option to change the root directory, you don't have to be super-user though as long as you have sufficient right to that directory tree.

OPTIONS

-v --verbose
    Verbose mode. Print current version number, the name of each directory as it is scanned and any links that are created.

-n  Only process directories specified on the command line. Don't process the trusted directories (/usr/lib and /lib) nor those specified in /etc/ld.so.conf. Implies -N.

-N  Don't rebuild the cache. Unless -X is also specified, links are still updated.

-X  Don't update links. Unless -N is also specified, the cache is still rebuilt.

-f conf
    Use conf instead of /etc/ld.so.conf.

-C cache
    Use cache instead of /etc/ld.so.cache.

-r root
    Change to and use root as the root directory.

-l  Library mode. Manually link individual libraries. Intended for use by experts only.

-p --print-cache
    Print the lists of directories and candidate libraries stored in the current cache.

-c --format=FORMAT
    Use FORMAT for the cache file. Choices are old, new and compat (the default).

-? --help --usage
    Print usage information.

-V --version
    Print version and exit.

EXAMPLES
    # /sbin/ldconfig -v
will set up the correct links for the shared binaries and rebuild the cache.
    # /sbin/ldconfig -n /lib
as root after the installation of a new shared library will properly update the shared library symbolic links in /lib.

FILES
/lib/ld-linux.so.*
    execution time linker/loader
/etc/ld.so.conf
    File containing a list of colon, space, tab, newline, or comma spearated directories in which to search for libraries.
/etc/ld.so.cache
    File containing an ordered list of libraries found in the directories specified in /etc/ld.so.conf. This file is not in human readable format, and is not intended to be edited.
lib*.so.version
    shared libraries

SEE ALSO
ldd(1), ld.so(8).

BUGS

ldconfig, being a user process, must be run manually and has no means of dynamically determining and relinking shared libraries for use by ld.so when a new shared library is installed.

AUTHORS
Andreas Jaeger. Manual page written by David Engel and Mitch D'Souza.